# HybridBackend

## Introduction

### Deep recommenders matter

Recommenders are now everywhere. Search, recommendations and online
advertising are at the heart of the Internet. Meanwhile, recommenders are
getting deeper and bigger. In industry, a training job for large deep
recommenders might consumes 10k+ CPU hours and 100GB+ storage.

![perf](images/recommenders.png)

### Cloud makes the difference

With the benefit of cloud infrastructure, it's easy to use modern compute power
and elastic storage service. However, training of large deep recommenders on
cloud still suffers from high financial cost and low resource utilization due
to lack of appropriate training framework.

### HybridBackend bridges the gap

HybridBackend could dramatically improve training performance of large deep
recommender by bridging the gap between cloud infrastructure and model training.

![perf](images/hbperf.png)
